#!/usr/bin/python3

import argparse
import shutil
import os
import glob
from boottoolsfunctions import _run

def boottoolsInitrdGenerate (osrelease):
    for f in glob.glob ('/usr/lib/initramfs-tools/bin/*'):
        os.unlink (f)
    shutil.copy ('/bin/busybox', '/usr/lib/initramfs-tools/bin')

    os.chdir ('/tmp')
    _run (['mkinitramfs', '-o', f'/tmp/initrd.img-{osrelease}', '-v', osrelease])
    shutil.copy (f'/boot/vmlinuz-{osrelease}', '/tmp/')

if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    parser.add_argument ('--osrelease', help='OS release', action='store', required=True)
    args = parser.parse_args()
    boottoolsInitrdGenerate (args.osrelease)
